config/routes.rb
QuestionBank::Application.routes.draw do
  resources :user_groups

  resources :question_groups

  resources :tags

  resources :attempts

  resources :questions

  get '/questions/quiz/new' => 'questions#prepare_quiz', :as => 'prepare_quiz'
  post '/questions/quiz/new'=> 'questions#generate_quiz', :as => 'generate_quiz'
  match '/questions/quiz/tag/:tag/num/:number_of_questions/show' => 'questions#show_quiz', :as => 'show_quiz'

  get '/downloads/new' => 'downloads#new', :as => 'new_download'
  post '/downloads' => 'downloads#create', :as => 'create_download'

  get '/uploads/new' => 'uploads#new', :as => 'new_upload'
  post '/uploads' => 'uploads#create', :as => 'create_upload'
  get '/uploads/attribute/new' => 'uploads#new_attribute', :as => 'new_attribute'
  post '/uploads/attribute/new' => 'uploads#create_attribute', :as => 'create_attribute'

  post '/api/event/new' => 'api#new_event'
  
  root :to => "home#index"
  resources :users, :only => [:index, :show, :edit, :update ]
  match '/auth/:provider/callback' => 'sessions#create'
  match '/signin' => 'sessions#new', :as => :signin
  match '/signout' => 'sessions#destroy', :as => :signout
  match '/auth/failure' => 'sessions#failure'
end

app/models/attempt.rb
class Attempt < ActiveRecord::Base
  belongs_to :question
  belongs_to :user

  attr_accessible :answer, :is_correct, :created_at, :question_id, :user_id, :updated_at
  
  def self.retrieve_by_user_group(user_group_id) 
  	Attempt.includes(:user => [:user_groups]).where("user_groups.id = ?", user_group_id)
  end

  def self.retrieve_by_question_group(question_group_id) 
  	Attempt.includes(:question => [:question_groups]).where("question_groups.id = ?", question_group_id)
  end

  def self.retrieve_by_user_group_and_question_group(user_group_id, question_group_id)
	Attempt.includes(:user => [:user_groups], :question => [:question_groups]).where("user_groups.id = ? and question_groups.id = ?", user_group_id, question_group_id)
  end
end

app/controllers/attempts_controller.rb
class AttemptsController < ApplicationController
  load_and_authorize_resource
  # GET /attempts
  # GET /attempts.json
  def index
    @attempts = Attempt.accessible_by(current_ability)

    respond_to do |format|
      format.html # index.html.erb
      format.json { render json: @attempts }
    end
  end

  # GET /attempts/1
  # GET /attempts/1.json
  def show
    @attempt = Attempt.find(params[:id])

    respond_to do |format|
      format.html # show.html.erb
      format.json { render json: @attempt }
    end
  end

  # GET /attempts/new
  # GET /attempts/new.json
  def new
    @attempt = Attempt.new

    respond_to do |format|
      format.html # new.html.erb
      format.json { render json: @attempt }
    end
  end

  # GET /attempts/1/edit
  def edit
    @attempt = Attempt.find(params[:id])
  end

  # POST /attempts
  # POST /attempts.json
  def create
    @attempt = Attempt.new(params[:attempt])

    respond_to do |format|
      if @attempt.save
        format.html { redirect_to @attempt, notice: 'Attempt was successfully created.' }
        format.json { render json: @attempt, status: :created, location: @attempt }
      else
        format.html { render action: "new" }
        format.json { render json: @attempt.errors, status: :unprocessable_entity }
      end
    end
  end

  # PUT /attempts/1
  # PUT /attempts/1.json
  def update
    @attempt = Attempt.find(params[:id])

    respond_to do |format|
      if @attempt.update_attributes(params[:attempt])
        format.html { redirect_to @attempt, notice: 'Attempt was successfully updated.' }
        format.json { head :no_content }
      else
        format.html { render action: "edit" }
        format.json { render json: @attempt.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /attempts/1
  # DELETE /attempts/1.json
  def destroy
    @attempt = Attempt.find(params[:id])
    @attempt.destroy

    respond_to do |format|
      format.html { redirect_to attempts_url }
      format.json { head :no_content }
    end
  end
end

app/helpers/attempts_helper.rb
module AttemptsHelper
end

app/views/attempts/_form.html.haml
= simple_form_for(@attempt) do |f|
  = f.error_notification

  .form-inputs
    = f.association :question
    = f.association :user
    = f.input :answer
    = f.input :is_correct, :label => "Correct?"
    = f.submit 'Save', :class => 'btn btn-primary'

app/views/attempts/edit.html.haml
%h3 Edit Attempt

= render 'form'

app/views/attempts/index.html.haml
%h3 Attempts

= link_to 'Create Attempt', new_attempt_path, :class => 'btn btn-primary'

%br 
%br

%table.table.table-striped
  %tr
    %th Answer
    %th User
    %th Question
    %th Correct?
    %th Created
    %th

  - @attempts.each do |attempt|
    %tr
      %td= link_to attempt.answer, attempt unless attempt.answer.blank?
      %td= attempt.user.name unless attempt.user.blank?
      %td= attempt.question.xml unless attempt.question.blank?
      %td= attempt.is_correct unless attempt.is_correct.blank?
      %td= format_date(attempt.created_at) unless attempt.created_at.blank?
      %td
        = link_to 'Destroy', attempt, method: :delete, data: { confirm: 'Are you sure?' }, :class => 'btn btn-danger index-action pull-right'
        = link_to 'Edit', edit_attempt_path(attempt), :class => 'btn btn-primary index-action pull-right'
%br

app/views/attempts/new.html.haml
= link_to 'Back to Attempts', attempts_path

%h1 Create Attempt

= render 'form'

app/views/attempts/show.html.haml
%h3 Attempt

= link_to 'Edit', edit_attempt_path(@attempt)

%dl
  %dt Question
  %dd= @attempt.question.xml

  %dt User
  %dd= @attempt.user.name

  %dt Answer
  %dd= @attempt.answer

  %dt Correct?
  %dd= @attempt.is_correct

  %dt Created
  %dd= format_date(@attempt.created_at)

 